<?php

class Login extends CI_Controller {
    private function is_valid_file($rel_path = '/', $file_html = 'home.html')
    {
        $abs_path = APPPATH.$rel_path.$file_html;
        if (file_exists($abs_path))
            return true;

        return false;
    }

    private function is_post_valid()
    {
        return $this->form_validation->run();
    }

    private function is_username_valid($username = NULL, $db_username = NULL)
    {
        if (!$username || !$db_username)
            return false;

        return !strcmp($username, $db_username);
    }

    private function is_password_valid($password = NULL, $db_password = NULL)
    {
        if (!$password || !$db_password)
            return false;

        return verify_password($password, $db_password);
    }

    private function is_login_valid($db_username = NULL, $db_password = NULL)
    {
        if (!$db_username || !$db_password)
            return false;

        $username = $this->input->post('username');
        $password = $this->input->post('password');

        if (!$this->is_username_valid($username, $db_username))
            return false;

        if (!$this->is_password_valid($password, $db_password))
            return false;

        return true;
    }

    public function view($file_name = 'login')
    {
        $file_html = $file_name.'.html';
        if ($this->is_valid_file('views/page/', $file_html))
        {
            /* Got to open a connection here as validation may require one */
            if (!$this->load->database())
                redirect(base_url('index.html'));

            $this->load->helper(array('form', 'url'));
            $this->load->library('form_validation');

            $this->form_validation->set_rules('username', 'Username', 'required',
                array('required' => 'You must provide a %s')
            );

            $this->form_validation->set_rules('password', 'Password', 'required',
                array('required' => 'You must provide a %s')
            );

            if ($this->is_post_valid())
            {
                /* Add backticks on ientifiers */
                $this->db->protect_identifiers('users', TRUE);

                /* Always use query bindings as they are automatically escaped */
                $stmt = "SELECT FROM users (username, password)";
                $data = $this->db->query($stmt, $data);

                /* Return an array of row objects, empty array on failure */
                $db_data = $data->result();
                if ($db_data && $db_data[0])
                {
                    $db_username = $db_data[0]->username;
                    $db_password = $db_data[0]->password;
                    if (is_login_valid($db_username, $db_passowrd))
                    {
                        /* Initialize session data */
                        $this->form_validation->set_string('Login successful');
                    }
                    else
                    {
                        /* Debug:
                         *
                         * $error = $this->db->error();
                         * var_dump($error);
                         */
                        $this->form_validation->set_message('submit_msg', 'Didn\'t work, :|');
                    }
                }
            }

            /* Validation errors already set, if any */
            $this->db->close();
            $this->load->view('page/'.$file_html);
        }
        else
        {
            redirect(base_url('index.html'));
        }
    }
}
